/*
 * Copyright (C)
 * Author:
 * License:
 */

#include <string.h>
#include <libmockturtle-rt.h>
#include <{{short_name}}-common-fw.h>

enum rt_slot_name {
	{{short_name_capital}}_CMD_IN = 0,
	{{short_name_capital}}_CMD_OUT,
};

static struct rt_mq mq[] = {
	[{{short_name_capital}}_CMD_IN] = {
		.index = 0,
		.flags = RT_MQ_FLAGS_LOCAL | RT_MQ_FLAGS_INPUT,
	},
	[{{short_name_capital}}_CMD_OUT] = {
		.index = 0,
		.flags = RT_MQ_FLAGS_LOCAL | RT_MQ_FLAGS_OUTPUT,
	},
};


static struct trtl_fw_variable variables[] = {
	/* put here variables that you want to share */
};

static struct rt_structure structures[] = {
	/* put here data structures that you want to share */
};

static trtl_fw_action_t *actions[] = {
	[RT_ACTION_RECV_PING] = rt_recv_ping,
	[RT_ACTION_RECV_VERSION] = rt_version_getter,
	[RT_ACTION_RECV_FIELD_SET] = trtl_fw_variable_setter,
	[RT_ACTION_RECV_FIELD_GET] = trtl_fw_variable_getter,
	[RT_ACTION_RECV_STRUCT_SET] = rt_structure_setter,
	[RT_ACTION_RECV_STRUCT_GET] = rt_structure_getter,
	/* Add your actions here */
};

struct trtl_fw_application app = {
	.name = "{{short_name}}",
	.version = {
		.fpga_id = FPGA_APPLICATION_ID,
		.rt_id = RT_APPLICATION_ID,
		.rt_version = RT_VERSION(0, 1),
		.git_version = GIT_VERSION
	},
	.mq = mq,
	.n_mq = ARRAY_SIZE(mq),

	.structures = structures,
	.n_structures = ARRAY_SIZE(structures),

	.variables = variables,
	.n_variables = ARRAY_SIZE(variables),

	.actions = actions,
	.n_actions = ARRAY_SIZE(actions),
};

/**
 * Well, the main :)
 */
int main()
{
	trtl_fw_init(&app);

	while (1) {
		/*
		 * Handle all messages incoming from slot
		 * {{short_name_capital}}_CMD_IN
		 * as actions
		 */
		trtl_fw_mq_action_dispatch({{short_name_capital}}_CMD_IN);
	}

	return 0;
}
