#include <mockturtle-rt.h>

int main()
{
	int i, k, n_word = sizeof(struct trtl_config_rom) / 4, size, cpu = 0;
	const struct trtl_config_rom *cfgrom = trtl_config_rom_get();
	const uint32_t *data = (const uint32_t *)cfgrom;
	uint32_t *msg, *hdr;


	pr_debug("CONFIG ROM\r\n");

	cpu = 0;
	size = TRTL_CONFIG_ROM_MQ_SIZE_PAYLOAD(cfgrom->hmq[cpu][0].sizes);
	for (i = 0; i < (n_word / size) + 1; ++i) {
		mq_claim(TRTL_HMQ, 0);
		hdr = mq_map_out_header(TRTL_HMQ, 0);
		msg = mq_map_out_buffer(TRTL_HMQ, 0);
		for (k = 0; k < size; k++) {
			if (i * size + k >= n_word)
				break;
			msg[k] = data[i * size + k];
			pr_debug("%p = 0x%08"PRIx32"\r\n",
				 &data[i * size + k],
				 data[i * size + k]);
		}
		hdr[0] = size - 1; /* last valid index */
		mq_send(TRTL_HMQ, 0);
	}

	return 0;
}
