#include <mockturtle-rt.h>

int main()
{
	int i, n_word, depth, slot, cpu, hmq;
	const struct trtl_config_rom *cfgrom = trtl_config_rom_get();
	volatile uint32_t *msg;
	uint32_t sizes;
	volatile struct trtl_hmq_header *hdr;

	pr_debug("ASYNC MESSAGES RECV\r\n");
	cpu = 0;
	for (hmq = 0; hmq < cfgrom->n_hmq[cpu]; ++hmq)
		mq_purge(TRTL_HMQ, hmq);

	for (hmq = 0; hmq < cfgrom->n_hmq[cpu]; ++hmq) {
		sizes = cfgrom->hmq[cpu][hmq].sizes;
		n_word = TRTL_CONFIG_ROM_MQ_SIZE_PAYLOAD(sizes);
		depth = TRTL_CONFIG_ROM_MQ_SIZE_ENTRIES(sizes);
		for (slot = 0; slot < depth; ++slot) {
			pr_debug("\tcpu: %d, hmq: %d, len: %d\r\n",
				 cpu, hmq, n_word);

			mq_claim(TRTL_HMQ, hmq);
			hdr = mq_map_out_header(TRTL_HMQ, hmq);
			msg = mq_map_out_buffer(TRTL_HMQ, hmq);
			hdr->len = n_word;
			for (i = 0; i < hdr->len; i++)
				msg[i] = i;
			mq_send(TRTL_HMQ, hmq);
		}
	}

	return 0;
}
