#include <mockturtle-rt.h>


int main()
{
	int cpu, hmq;
	const struct trtl_config_rom *cfgrom = trtl_config_rom_get();
	volatile uint32_t *msg;
	volatile struct trtl_hmq_header *hdr;
	int wait = 0, max_wait_cycle, count;

	pr_debug("ASYNC MESSAGES SEND\r\n");

	cpu = 0;
	for (hmq = 0; hmq < cfgrom->n_hmq[cpu]; ++hmq) {
		wait = (1 << hmq);
		hdr = mq_map_in_header(TRTL_HMQ, hmq);
		msg = mq_map_in_buffer(TRTL_HMQ, hmq);
		count = 1;
		max_wait_cycle = 0xFFFF;
		while (1) {
			/* Wait incoming message */
			while ((mq_poll_in(TRTL_HMQ) & wait) != wait) {
				if (--max_wait_cycle == 0) {
					pr_error("\tNO MESSAGE PENDING h:%d, cnt:0x%x\r\n",
						 hmq, count);
					return -1;
				}
			}

			/* validate message */
			if (hdr->len != 2 || msg[0] != count) {
				pr_error("\th: %d, l:%d, d[0]:0x%lx, cnt:0x%x\r\n",
					 hmq, hdr->len, msg[0], count);
				mq_discard(TRTL_HMQ, hmq);
				return -1;
			}
			if (msg[1] < count) {
				pr_error("\th:%d, l:%d d[1]:0x%lx, cnt:0x%x\r\n",
					 hmq, hdr->len, msg[1], count);
				mq_discard(TRTL_HMQ, hmq);
				return -1;
			}

			/* stop on the last one */
			if (msg[0] == msg[1]) {
				mq_discard(TRTL_HMQ, hmq);
				break;
			}

			/* goto the next one */
			mq_discard(TRTL_HMQ, hmq);
			count++;
		}
	}

	pp_printf("OK\r\n");
	return 0;
}
