#include <mockturtle-rt.h>

int main()
{
	int cpu, hmq;
	const struct trtl_config_rom *cfgrom = trtl_config_rom_get();

	pr_debug("PURGE MESSAGES\r\n");
	pr_debug("Fill the HMQ while CPU is not running\r\n");

	cpu = 0;
	for (hmq = 0; hmq < cfgrom->n_hmq[cpu]; ++hmq) {
		if ((mq_poll_in(TRTL_HMQ) & (1 << hmq)) != (1 << hmq)) {
			pr_error("HMQ-%d after poll: 0x%"PRIx32"\r\n",
				 hmq, mq_poll_in(TRTL_HMQ));
			return -1;
		}

		mq_purge(TRTL_HMQ, hmq);

		if ((mq_poll_in(TRTL_HMQ) & (1 << hmq)) == (1 << hmq)) {
			pr_error("HMQ-%d after poll: 0x%"PRIx32"\r\n",
				 hmq, mq_poll_in(TRTL_HMQ));
			return -1;
		}
	}

	if (mq_poll_in(TRTL_HMQ) != 0) {
		pr_error("END poll: 0x%"PRIx32"\r\n", mq_poll_in(TRTL_HMQ));
		return -1;
	}

	pp_printf("OK\r\n");
	return 0;
}
