import os
import pytest
import time

@pytest.fixture
def trtl_binary_frm_var(trtl_firmware_dir):
    return os.path.join(trtl_firmware_dir,
                        "firmware/rt-frm-var/fw-rt-frm-var.bin")

@pytest.fixture
def trtl_binary_frm_ping(trtl_firmware_dir):
    return os.path.join(trtl_firmware_dir,
                        "firmware/rt-frm-ping/fw-rt-frm-ping.bin")

@pytest.fixture
def trtl_binary_frm_version(trtl_binary_frm_ping):
    return trtl_binary_frm_ping

class TestFirmwareFramework(object):
    def test_var(self, trtl_cpu0, trtl_binary_frm_var):
        trtl_cpu0.load_application_file(trtl_binary_frm_var)
        trtl_cpu0.enable()
        time.sleep(0.1)

    def test_ping(self, trtl_cpu0, trtl_binary_frm_ping):
        trtl_cpu0.load_application_file(trtl_binary_frm_ping)
        trtl_cpu0.enable()
        time.sleep(0.1)

        assert trtl_cpu0.ping() == True

    def test_ver(self, trtl_cpu0, trtl_binary_frm_version):
        trtl_cpu0.load_application_file(trtl_binary_frm_version)
        trtl_cpu0.enable()
        time.sleep(0.1)

        assert trtl_cpu0.ping() == True
